
#ifndef FREERTOS_CONFIG_H
#define FREERTOS_CONFIG_H

#define portPOINTER_SIZE_TYPE int

#define configUSE_PREEMPTION			1
#define configUSE_IDLE_HOOK			0
#define configUSE_TICK_HOOK			0
#define configCPU_CLOCK_HZ			( ( unsigned long ) 80000000 )
#define configTICK_RATE_HZ			( ( portTickType ) 10000)
#define configMAX_PRIORITIES		8
#define configMINIMAL_STACK_SIZE	100 
#define configTOTAL_HEAP_SIZE		4096 
#define configMAX_TASK_NAME_LEN		8 
#define configUSE_TRACE_FACILITY	0
#define configUSE_16_BIT_TICKS		0
#define configIDLE_SHOULD_YIELD		1


#define configUSE_PORT_OPTIMISED_TASK_SELECTION	0

/* Co-routine definitions. */
#define configUSE_CO_ROUTINES 		1
#define configMAX_CO_ROUTINE_PRIORITIES ( 2 )

/* Set the following definitions to 1 to include the API function, or zero
to exclude the API function. */

#define INCLUDE_vTaskPrioritySet		1
#define INCLUDE_uxTaskPriorityGet		1
#define INCLUDE_vTaskDelete			1
#define INCLUDE_vTaskCleanUpResources		1
#define INCLUDE_vTaskSuspend			1
#define INCLUDE_vTaskDelayUntil			1
#define INCLUDE_vTaskDelay			1


#endif /* FREERTOS_CONFIG_H */
