/* Critical section management. */
.alias SP 39	; stack pointer
.alias BP 38	; function frame base pointer
.alias SI 37	; source address
.alias DI 36	; destination address
.alias CX 35	; counter

.global portENTER_CRITICAL
.global portEXIT_CRITICAL
.global portDISABLE_INTERRUPTS
.global portENABLE_INTERRUPTS
.global nop


.text

nop:
	rdl #SP
	jmp @1	
complete

portENTER_CRITICAL:
	rdl #SP
	jmp @1
	setl #MSKR, 0
complete

portEXIT_CRITICAL:
	rdl #SP
	jmp @1
	setl #MSKR, 0xffffffff
complete

portDISABLE_INTERRUPTS:
	rdl #SP
	jmp @1
	setl #MSKR, 0
complete

portENABLE_INTERRUPTS:
	rdl #SP
	jmp @1
	setl #MSKR, 0xffffffff
complete



//#define portENTER_CRITICAL()		//asm volatile ( "in		__tmp_reg__, __SREG__" :: );	\
//									asm volatile ( "cli" :: ///);								\
///									asm volatile ( "push	__tmp_reg__" :: )
//
//#define portEXIT_CRITICAL()			//asm volatile ( "pop		__tmp_reg__" :: );				\
//									asm volatile ( "out		__SREG__, __tmp_reg__" :: )

//#define portDISABLE_INTERRUPTS()	//asm volatile ( "cli" :: );
//#define portENABLE_INTERRUPTS()		//asm volatile ( "sei" :: );
