#include "FreeRTOS.h"
#include "task.h"

/*-----------------------------------------------------------*/

/* We require the address of the pxCurrentTCB variable, but don't want to know
any details of its type. */
//typedef void tskTCB;
extern struct tskTCB * volatile pxCurrentTCB;

/*-----------------------------------------------------------*/

/* 
 * See header file for description. 
 */
portSTACK_TYPE *pxPortInitialiseStack( portSTACK_TYPE *pxTopOfStack, pdTASK_CODE pxCode, void *pvParameters )
{
unsigned int usAddress;


	*pxTopOfStack = ( unsigned int )(pxTopOfStack - 12);	// для BP
	pxTopOfStack--;

	*pxTopOfStack = ( unsigned int )(pxTopOfStack - 12);	// для SP
	pxTopOfStack--;

	usAddress = ( unsigned int ) pxCode;
	*pxTopOfStack = ( portSTACK_TYPE ) usAddress ;
	pxTopOfStack--;

	*pxTopOfStack = (int)pvParameters;
	pxTopOfStack--;

	*pxTopOfStack = 0xA0;
	pxTopOfStack--;

	*pxTopOfStack = 0xA1;
	pxTopOfStack--;

	*pxTopOfStack = 0xA2;
	pxTopOfStack--;

	*pxTopOfStack = 0xA3;
	pxTopOfStack--;

	*pxTopOfStack = 0xA4;
	pxTopOfStack--;

	*pxTopOfStack = 0xA5;
	pxTopOfStack--;

	*pxTopOfStack = 0xA6;
	pxTopOfStack--;

	*pxTopOfStack = 0xA7;
	
	pxTopOfStack--;  

	*pxTopOfStack = (int)pvParameters;  // pvParameters выполняемой задачи.

	pxTopOfStack--;  

	*pxTopOfStack = 0x0;                // Адрес уходы в случае ошибки.

	pxTopOfStack--;    // <- +SIZE регистры и задача, -SIZE стек задачи
				// Тут будет #BP задачи.


	return pxTopOfStack;
}
/*-----------------------------------------------------------*/

portBASE_TYPE xPortStartScheduler( void )
{
	/* Setup the hardware to generate the tick. */
	initSysTimer(0,TPERIOD,TPREDDIV);

	/* Restore the context of the first task that is going to run. */
	PRS();


	/* Should not get here. */
	return pdTRUE;
}
/*-----------------------------------------------------------*/

void vPortEndScheduler( void )
{

}

#if configUSE_PREEMPTION == 1

	/*
	 * Tick ISR for preemptive scheduler.  We can use a naked attribute as
	 * the context is saved at the start of vPortYieldFromTick().  The tick
	 * count is incremented after the context is saved.
	 */
	void sysTimerHandler()
	{
		portSAVE_CONTEXT();

		if( xTaskIncrementTick() != pdFALSE )
		{
			vTaskSwitchContext();
		}

		portRESTORE_CONTEXT();

		initSysTimer(0,TPERIOD,TPREDDIV);
	}
#else

	/*
	 * Tick ISR for the cooperative scheduler.  All this does is increment the
	 * tick count.  We don't need to switch context, this can only be done by
	 * manual calls to taskYIELD();
	 */
	void sysTimerHandler()
	{
		xTaskIncrementTick();
		initSysTimer(0,TPERIOD,TPREDDIV);
	}
#endif



	
